#!/usr/bin/perl -w

package lace;

#Takes no arguments, returns a string:
#returns:
 #Telecined
 #Interlaced
 #Progressive
 #Progressive/Telecined
 #Progressive/Interlaced
sub get_lace {
    if( !defined $::dvd->{'track'}) {
        return "frame detection failed";
    }
    
    $video = shift;
    my $to30 = 0;
    my $to24 = 0;

    open(PIPE, "$video -quiet -nosound -vo null -benchmark -sstep 100 2>&1 |") || die "can't fork: $!";;
    while (<PIPE>) {
        chomp $_;
        if ($_ eq 'demux_mpg: 24000/1001fps progressive NTSC content detected, switching framerate.') {
            if(++$to24 > 1) {
                close(PIPE);
                last;
            }
        } 
    }

#affinity: .0++1..2+.3.
#breaks:   .0..1.|2..3.
#duration: 2
    #
#affinity: .0+.1.+2..3+
#breaks:   |0..1..2|.3.
#duration: 3

    my $pos = 0;
    my $mcount = 0;

    my $count = 0;;
    if($to24 == 0) {
        #all telecined or all interlaced
        open(TEST, "$video -vf pullup,softskip -v -quiet -nosound -vo null -benchmark 2>&1 |") || die "can't fork: $!";;
        while (<TEST>) {
            if(substr($_, 0, 9) eq "affinity:") {
                if(substr($_, 11, 4)  eq '0++1'){
                    if($pos == 0) {
                        $pos = 1;
                        $mcount = 0;
                    } elsif ($pos == 2) {
                        $pos = 1;
                        $mcount++;
                    } else {
                        $mcount = 0;
                        $pos = 0;
                    }
                } elsif (substr($_, 11, 7) eq '0+.1.+2') {
                    if($pos == 0) {
                        $pos = 2;
                        $mcount = 0;
                    } elsif ($pos == 1) {
                        $pos = 2;
                        $mcount++;
                    } else {
                        $mcount = 0;
                        $pos = 0;
                    }
                } else {
                    $mcount = 0;
                    $pos = 0;
                }
                $count++;
            }
            if($mcount > 100){
                close(TEST);
                return "Telecined";
                exit;
            }
            if($count > 200) {
                close(TEST);
                return "Interlaced";
                exit;
            }
        }
        close(TEST);
        return "Interlaced";
    } elsif($to24 == 1) {
        #progressive
        return "Progressive";
    } else {
#        open(TEST, "$video -vf pullup,softskip -v -quiet -nosound -vo null -benchmark 2>&1 |") || die "can't fork: $!";;
#        while (<TEST>) {
#            if(substr($_, 0, 9) eq "affinity:") {
#                if(substr($_, 11, 4)  eq '0++1'){
#                    if($pos == 0) {
#                        $pos = 1;
#                        $mcount = 0;
#                    } elsif ($pos == 2) {
#                        $pos = 1;
#                        $mcount++;
#                    } else {
#                        $mcount = 0;
#                        $pos = 0;
#                    }
#                } elsif (substr($_, 11, 7) eq '0+.1.+2') {
#                    if($pos == 0) {
#                        $pos = 2;
#                        $mcount = 0;
#                    } elsif ($pos == 1) {
#                        $pos = 2;
#                        $mcount++;
#                    } else {
#                        $mcount = 0;
#                        $pos = 0;
#                    }
#                } else {
#                    $mcount = 0;
#                    $pos = 0;
#                }
#            }
#            if($mcount > 5){
#                close(TEST);
                return "Telecined/Progressive";
#                exit;
#            }
#        }
#        close(TEST);
#        return "Interlaced/Progressive";
    }
}

1;
